/**
 * gmail_panel namespace.
 */
if ("undefined" == typeof(gmail_panel)) {
  var gmail_panel = {};
};

gmail_panel.sibPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
gmail_panel.previousUnreadMails = 0;

gmail_panel.BrowserOverlay = {

	resizePanel: function(){ //resize the panel with the preference %.
		var panelWidth = gmail_panel.sibPref.getIntPref("extensions.gmail_panel.panelWidth")/100;
		var panelHeight = gmail_panel.sibPref.getIntPref("extensions.gmail_panel.panelHeight")/100;
		var panel = document.getElementById("gmail_panel-panel");
		panel.sizeTo(window.screen.availWidth*panelWidth,window.screen.availHeight*panelHeight);
	},
  
  showGmailPopup: function (unreadMails){
  /*//If the popup is clicked, the panel is opened but also it's closed immediately. 
  //So I leave commented the "clickListener" and make the notificaction not clickable.
  
    var clickListener = {
      observe: function(subject, topic, data) {        
        if(topic == 'alertclickcallback'){
          
          var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                           .getInterface(Components.interfaces.nsIWebNavigation)
                           .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                           .rootTreeItem
                           .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                           .getInterface(Components.interfaces.nsIDOMWindow);
          var gmailPanel = mainWindow.document.getElementById("gmail_panel-panel");
          var gmailButton = mainWindow.document.getElementById("gmail_panel-toolbar-button");
          gmailPanel.openPopup(gmailButton, "", 0, 0, false, false);
          
        };
      }
    }
    */
    
    var gpStringsBundle = document.getElementById("gmail_panel-string-bundle");    
    var unreadMailsDesc = gpStringsBundle.getString('unreadMailsDesc');
    var countUnreadMailsDesc = gpStringsBundle.getFormattedString('countUnreadMailsDesc', [unreadMails]);
    
    var popupService = Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService);
    
    popupService.showAlertNotification(
      "chrome://gmail_panel/content/googlemail-48.png", //AString imageUrl
      unreadMailsDesc, //AString title
      countUnreadMailsDesc, //AString text
      false, //boolean textClickable
      "", //AString cookie
      null, //nsIObserver alertListener
      "" //AString name
    );
  },
  
  notificationHandler: function (unreadMails){
    var showNotifications = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.showNotifications");
    var soundNotifications = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.soundNotifications");
    var sound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
    if(showNotifications){
      var notificationsRepetitive = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.notificationsRepetitive");
      if(notificationsRepetitive){
        gmail_panel.BrowserOverlay.showGmailPopup(unreadMails);
        if(soundNotifications){
          sound.playEventSound('EVENT_NEW_MAIL_RECEIVED');
        };
      } else {
        if (gmail_panel.previousUnreadMails < unreadMails){
          gmail_panel.BrowserOverlay.showGmailPopup(unreadMails);
          if(soundNotifications){
            sound.playEventSound('EVENT_NEW_MAIL_RECEIVED');
          };
        };
      };
    };
  },
  
  setGmailIcon: function (){
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIWebNavigation)
                     .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                     .rootTreeItem
                     .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIDOMWindow);

    var gmailButton = mainWindow.document.getElementById("gmail_panel-toolbar-button");
    var gmailIframeContent = mainWindow.document.getElementById("gmail_panel-iframe").contentDocument;
    
    try{
      var faviconURL = gmailIframeContent.getElementsByTagName('link')[1].href;
      if ((faviconURL.search("/images/2/unreadcountfavicon/") > -1)){ //If it = -1 means that its a non valid image.
        gmailButton.setAttribute("image",faviconURL);
      } else {
        gmailButton.setAttribute("image","chrome://gmail_panel/content/favicon.png");
      };
    }catch(e){
      //do nothing
    };
  },
  
  setGmailIframe: function (iframe_url){
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIWebNavigation)
                     .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                     .rootTreeItem
                     .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIDOMWindow);
    
    var gmailIframe = mainWindow.document.getElementById("gmail_panel-iframe");
		gmailIframe.webNavigation.loadURI(iframe_url,'LOAD_FLAGS_NONE',null,null,null);   
        
  },
  
  checkIframe: function(){
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIWebNavigation)
                     .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                     .rootTreeItem
                     .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIDOMWindow);
    
    var gmailIframe = mainWindow.document.getElementById("gmail_panel-iframe");
    if(gmailIframe.webNavigation.currentURI.spec == "chrome://gmail_panel/content/gp-loading.xul"){ 
      //If the user opens the panel before it is loaded for the first time, I load it.
      //If it's loaded, I do nothing, because it's pretty annoying loading every time you open the panel because the load has a little delay. 
      //Also, you might lose information.
      gmail_panel.BrowserOverlay.setGmailIframe('http://mail.google.com');
    };
  },
  
  checkMail: function (){ //Check the mails and refresh the button's image with de Gmail's favicon.
    gmail_panel.BrowserOverlay.checkIframe();
    try{
      window.clearTimeout(gmail_panel.checkMailTimeOut);
    }catch(e){
      //Do nothing. Because in the first Run isn't defined the timeout.
    };

    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIWebNavigation)
                     .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                     .rootTreeItem
                     .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                     .getInterface(Components.interfaces.nsIDOMWindow);

    var gmailIframeContent = mainWindow.document.getElementById("gmail_panel-iframe").contentDocument;
		
    try{
      var faviconURL = gmailIframeContent.getElementsByTagName('link')[1].href;
      if ((faviconURL.search("0.png") > -1)){ //If it = -1 means that there are unread emails.
        gmail_panel.previousUnreadMails = 0;
      } else {
        var unreadMails = faviconURL.split('/')[9].split('.')[0];
        gmail_panel.BrowserOverlay.notificationHandler(unreadMails);
        gmail_panel.previousUnreadMails = unreadMails;
      };
      //delay 300 miliseconds SetGmailIcon to let the user know that is "loading".
      var setGmailIconTimeOut = setTimeout(function() {gmail_panel.BrowserOverlay.setGmailIcon();}, 1*300);
      //Set the setTimeout again
      gmail_panel.checkMailTimeOut = setTimeout(function() {gmail_panel.BrowserOverlay.checkMail(); }, 
                                        gmail_panel.sibPref.getIntPref("extensions.gmail_panel.refreshTime")*
                                        60*
                                        1000);
    }catch(e){
      //var button = document.getElementById("gmail_panel-toolbar-button");
      //button.setAttribute("image","chrome://gmail_panel/content/favicon.gif");
      //If is not loaded Gmail, recheck every 1 second.
      gmail_panel.checkMailTimeOut = setTimeout(function() {gmail_panel.BrowserOverlay.checkMail(); },1000);
    };
  },
  
  checkMailNow: function (){
    var button = document.getElementById("gmail_panel-toolbar-button");
    button.setAttribute("image","chrome://gmail_panel/content/loading.gif");
    gmail_panel.BrowserOverlay.checkMail();
  },
  
  pinGmailPanel: function (){
    var panel = document.getElementById("gmail_panel-panel");
    var noautohide = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.noautohide");
    panel.setAttribute("noautohide", noautohide);
    var pinButton = document.getElementById("gmail_panel-toolbarButton_pin");
    pinButton.checked = noautohide;
  },
  
  changePinMode: function (){
    var pinMode = document.getElementById("gmail_panel-toolbarButton_pin").checked;
    gmail_panel.sibPref.setBoolPref("extensions.gmail_panel.noautohide", pinMode);
    gmail_panel.BrowserOverlay.pinGmailPanel();
    //Need to close and reopen the panel to make the change take effect.
    var panel = document.getElementById("gmail_panel-panel");
    panel.hidePopup();
    var button = document.getElementById("gmail_panel-toolbar-button");
    panel.openPopup(button, "", 0, 0, false, false);
  },
  
  autoHideToolbar: function (){
    var panelToolbar = document.getElementById("gmail_panel-panel-toolbar");
    var toolbarAutoHide = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.toolbarAutoHide");
    if(toolbarAutoHide){
      panelToolbar.classList.add("gmail_panel-toolbar-class-hide");
      panelToolbar.classList.remove("gmail_panel-toolbar-class-show");
      
    }else{
      panelToolbar.classList.add("gmail_panel-toolbar-class-show");
      panelToolbar.classList.remove("gmail_panel-toolbar-class-hide");
    };
    var autoHideButton = document.getElementById("gmail_panel-toolbarButton_autoHide");
    autoHideButton.checked = toolbarAutoHide;
  },
  
  changeAutoHideMode: function (){
    var pinMode = document.getElementById("gmail_panel-toolbarButton_autoHide").checked;
    gmail_panel.sibPref.setBoolPref("extensions.gmail_panel.toolbarAutoHide", pinMode);
    gmail_panel.BrowserOverlay.autoHideToolbar();
    //Need to close and reopen the panel to make the change take effect.
    var panel = document.getElementById("gmail_panel-panel");
    panel.hidePopup();
    var button = document.getElementById("gmail_panel-toolbar-button");
    panel.openPopup(button, "", 0, 0, false, false);
  },
  
  openGmailPanel: function (){
	  window.clearTimeout(gmail_panel.delayFirstRunTimeOut);
    
    gmail_panel.BrowserOverlay.resizePanel();
    gmail_panel.BrowserOverlay.checkIframe();
    gmail_panel.BrowserOverlay.setGmailIcon();
    gmail_panel.BrowserOverlay.pinGmailPanel();
    gmail_panel.BrowserOverlay.autoHideToolbar();
    window.clearTimeout(gmail_panel.checkMailTimeOut);
    
	},
  
  closeGmailPanel: function (){
    gmail_panel.BrowserOverlay.setGmailIcon();
    gmail_panel.checkMailTimeOut = setTimeout(function() {gmail_panel.BrowserOverlay.checkMail(); }, 
                                        gmail_panel.sibPref.getIntPref("extensions.gmail_panel.refreshTime")*
                                        60*
                                        1000);
  },
  
  installButton: function(toolbarId, id){
    if (!document.getElementById(id)){
        var toolbar = document.getElementById(toolbarId);
        var before = null;
        toolbar.insertItem(id, before);
        toolbar.setAttribute("currentset", toolbar.currentSet);
        document.persist(toolbar.id, "currentset");
    };
  },
  
  gpShortcut_cmd: function(){ //opens the panel with the shortcut.
    var panel = document.getElementById("gmail_panel-panel");
    var button = document.getElementById("gmail_panel-toolbar-button");
    panel.openPopup(button, "", 0, 0, false, false);
  },
  
  compose: function(){
    var panel = document.getElementById("gmail_panel-panel");
    var button = document.getElementById("gmail_panel-toolbar-button");
    gmail_panel.BrowserOverlay.setGmailIframe('chrome://gmail_panel/content/gp-loading.xul');
    var compose_timeout = setTimeout(
      function() {gmail_panel.BrowserOverlay.setGmailIframe('http://mail.google.com/mail/u/0/#compose');},
      1* 
      10
    ); 
    panel.openPopup(button, "", 0, 0, false, false);
  },
  
  onclick: function(event){
    switch(event.button) {
      case 0:
        // Left click
        break;
      case 1:
        // Middle click
        gmail_panel.BrowserOverlay.checkMailNow();
        break;
      case 2:
        // Right click
        break;
    };
  },
  
  initKeyset: function(){ //On Firefox loads sets the shortcut keys.
    var modifiers = gmail_panel.sibPref.getCharPref("extensions.gmail_panel.modfiers");
    var key = gmail_panel.sibPref.getCharPref("extensions.gmail_panel.key");
    var keyset = document.getElementById("gmail_panel-shortcut_cmd");
    keyset.setAttribute("modifiers",modifiers);
    keyset.setAttribute("key",key);
  },
  
  onFirefoxLoad: function(event){
    window.removeEventListener("load", function () { gmail_panel.BrowserOverlay.onFirefoxLoad(); }, false);
    var isFirstRunPref = gmail_panel.sibPref.getBoolPref("extensions.gmail_panel.isFirstRun");
    if (isFirstRunPref){
      gmail_panel.BrowserOverlay.installButton("nav-bar", "gmail_panel-toolbar-button");
      gmail_panel.sibPref.setBoolPref("extensions.gmail_panel.isFirstRun", false);
    };
    this.initKeyset(); //initiate the button's keyboard shortcut.
  },

};

window.addEventListener("load", function () { gmail_panel.BrowserOverlay.onFirefoxLoad(); }, false);

//Delay the first iframe load.
gmail_panel.delayFirstRunTimeOut = setTimeout(
    function() {
      gmail_panel.BrowserOverlay.setGmailIframe('http://mail.google.com');
      var button = document.getElementById("gmail_panel-toolbar-button");
      button.setAttribute("image","chrome://gmail_panel/content/loading.gif");
      gmail_panel.BrowserOverlay.checkMail();
    },
    gmail_panel.sibPref.getIntPref("extensions.gmail_panel.delayFirstRun")*
    1000
); 